# AC3D
# Copyright (c) 2016, Inivis Limited. All rights reserved.

# This is the very first tcl file to be sourced from AC3D.
# this is read before the preferences file. In here are some new preferences particularly the default UI col config




##################################                                                                                                                             
# capture stdout for debugging
# even if we change stdout in the c-code, it looks like tcl grabs it for puts.
# if the write method here is changed to puts to stdout - we get an infinate loop so we need to use a seperate log file
                                                                                                                                                

if {0} {


oo::class create StdoutCapture {

    constructor {} {
        set fo [open "/tmp/ac3dtclout.txt" w]
		close $fo
    }
    method initialize {handle mode} {
        if {$mode ne "write"} {error "can't handle reading"}
        return {finalize initialize write}
    }
    method finalize {handle} {
        # Do nothing, but mandatory that it exists                                                                                                             
    }

    method write {handle bytes} {

        set fo [open "/tmp/ac3dtclout.txt" a]
		fconfigure $fo -buffering none
        puts $fo "$bytes"
        close $fo

        # Return the empty string, as we are swallowing the bytes                                                                                              
        return ""
    }
}


# Attach an instance of the capturing transform                                                                                                                
set myBuffer ""
puts "GRABBING STDOUT IN TCL"
chan push stdout [StdoutCapture new]
puts "GRABBED STDOUT IN TCL"
}
# end if 0                                                                                                                                                     
#####################


	# these are the defaults for the UI setup (razor)
	array set defaultui { light #4b4b4b disabledbackground #313131 titlebackground #666666 dark #373737 disabledforeground #666666 border #2a2a2a font TkDefaultFont buttonhover #484848 background #313131 selectbackground #0080ff trough #292929 selectforeground #ffffff foreground #a8a8a8 buttonbackground #3c3c3c textcolor #c8c8c8 textbackground #2a2a2a }


	# array of saved UI settings 

	set ui_defaults "\
		Pebble {light #666666 disabledbackground #444444 titlebackground #666666 dark #565656 disabledforeground #888888 border #373737 font TkDefaultFont buttonhover #777777 background #444444 selectbackground #0080ff trough #363636 selectforeground #ffffff foreground #cccccc buttonbackground #5f5f5f textcolor #c8c8c8 textbackground #363636} \
		Alien {light #2e2e2e disabledbackground #333333 titlebackground #666666 dark #252525 disabledforeground #5d5d5d border #151515 font TkDefaultFont buttonhover #535353 background #141414 selectbackground #00b000 trough #000000 selectforeground #000000 foreground #acacac buttonbackground #232323 textcolor #c8c8c8 textbackground #000000} \
		Cloud { light #ffffff disabledbackground #444444 titlebackground #666666 dark #696969 disabledforeground #888888 border #f0f0f0 font TkDefaultFont buttonhover #ffffff background #f0f0f0 selectbackground #3c72ff foreground #000000 selectforeground #000000 buttonbackground #f0f0f0 textcolor #000000 textbackground #c0c0c0 }\
		Desert { background #c5af65 border #968138 buttonbackground #cbb876 buttonhover #cdba78 dark #ab9441 disabledbackground #c5af65 disabledforeground #999999 font TkDefaultFont foreground #353535 light #d1c087 selectbackground #e1d6ae selectforeground #ffffff textbackground #71612b textcolor #c8c8c8 titlebackground #666666 trough #71612b }\
		Disco { background #ff0000 border #d70428 buttonbackground #ff8040 buttonhover #484848 dark #8c8c8c disabledbackground #313131 disabledforeground #888888 font TkDefaultFont foreground #ffff0f light #ffffff selectbackground #ee11e9 selectforeground #ffffff textbackground #00ffff textcolor #008200 titlebackground #666666 trough #080808}\
		Grape { background #3c2c49 border #201726 buttonbackground #5b4370 buttonhover #8e6fa8 dark #32253d disabledbackground #313131 disabledforeground #888888 font TkDefaultFont foreground #a8a8a8 light #674d7d selectbackground #9f85b6 selectforeground #ffffff textbackground #2e2237 textcolor #c8c8c8 titlebackground #666666 trough #32253d }\
		Limitless { light #8d8d8d disabledbackground #5f5f5f titlebackground #666666 dark #8d8d8d disabledforeground #585858 border #8d8d8d font TkDefaultFont buttonhover #777777 background #8d8d8d selectbackground #0380dc trough #4a4a4a selectforeground #000000 foreground #e4e4e4 buttonbackground #a0a0a0 textcolor #c8c8c8 textbackground #6c6c6c }\
		{Pancake} {light #787878 disabledbackground #646464 titlebackground #666666 dark #787878 disabledforeground #585858 border #646464 font TkDefaultFont buttonhover #8c8c8c background #646464 selectbackground #ff6820 trough #4a4a4a selectforeground #ffffff foreground #dbdbdb buttonbackground #646464 textcolor #c8c8c8 textbackground #505050}\
		Razor {light #4b4b4b disabledbackground #313131 titlebackground #666666 dark #373737 disabledforeground #646464 border #2a2a2a font TkDefaultFont buttonhover #484848 background #313131 selectbackground #0080ff trough #292929 selectforeground #ffffff foreground #a8a8a8 buttonbackground #3c3c3c textcolor #c8c8c8 textbackground #2a2a2a}\
		Cinnamon {light #504b4b disabledbackground #373131 titlebackground #666666 dark #3c3737 disabledforeground #8d8888 border #2f2a2a font TkDefaultFont buttonhover #504848 background #373131 selectbackground #ae3800 trough #2e2929 selectforeground #fffafa foreground #b2a8a8 buttonbackground #3e3737 textcolor #c8c3c3 textbackground #2f2a2a}\
		Classic { background #f0f0f0 border #f0f0f0 buttonbackground #f0f0f0 buttonhover #ffffff dark #696969 disabledbackground #444444 disabledforeground #888888 font TkDefaultFont foreground #000000 light #ffffff selectbackground #0080ff selectforeground #000000 textbackground #ffffff textcolor #000000 titlebackground #666666 trough #292929 }\
		"




if {0} {
#show the Mac default fonts
 set mf { systemSmallSystemFont systemApplicationFont systemViewsFont systemMenuItemFont systemMenuItemCmdKeyFont systemPushButtonFont systemAlertHeaderFont systemMiniSystemFont systemDetailEmphasizedSystemFont systemEmphasizedSystemFont systemSmallEmphasizedSystemFont systemLabelFont systemMenuTitleFont systemMenuItemMarkFont systemWindowTitleFont  systemUtilityWindowTitleFont  systemToolbarFont  systemDetailSystemFont }

 toplevel .ft
 foreach { f } $mf {

	set a [font metrics $f -ascent ]
	set d [font metrics $f -descent ]
	set s [expr $a + $d ]

	set l [ttk::label .ft.lab$f -text "$f In the beginning the universe was created.  This has made a lot of people very angry and been widely regarded as a bad move. 1234567890.1234 $a $d $s" -font $f ]
	grid  $l -sticky w
 }

}


	# tkDefaultFont is quite big on Mac so replace it with a smaller one
# http://www.tkdocs.com/tutorial/fonts.html
	if { [tk windowingsystem] == "aqua" } {
#set macfont systemMiniSystemFont
#set macfont systemLabelFont
#set macfont systemDetailSystemFont
set macfont systemToolbarFont
set ui_defaults [string map "TkDefaultFont $macfont" $ui_defaults ]
		set defaultui(font) $macfont
		}


	if { [tk windowingsystem ] == "x11" } {
set lxfont "helvetica 8"
set ui_defaults [string map "TkDefaultFont \"\{$lxfont\}\"" $ui_defaults ]
		set defaultui(font) $lxfont
}



	# add the prefs_ui* prefs
	# when a pref is added, it creates a tcl var with a "prefs_" prefix

	foreach { name default} [array get defaultui] {
		ac3d add_pref ui($name) $default
	}


	# note  - booleans use 0 or 1

	ac3d add_pref ui_setting_all $ui_defaults
	ac3d add_pref ui_leftpane_sash_percent "50.0"
	set ac3d_default_gadgets "utils 1 visibility 0 surfacetype 0 objectname 0 extrude 0 palette 0 "
	ac3d add_pref ui_gadget_layout $ac3d_default_gadgets
	ac3d add_pref mainwin_maxed 1
	ac3d add_pref view_focus_under_mouse2 0
	ac3d add_pref ui_float_precision 5


proc set_default_ui_conf { what } {
# what can be "all", "font" or "cols"

	global prefs_ui defaultui

	foreach { name default} [array get defaultui] {
		if { ($what == "all") || (( $what == "font" ) && ($name == "font" )) || (($what == "cols") && ($name != "font")) } {
			set prefs_ui($name) $default
		}

	}
}



